<%@ page language="java" %>
<%@ page contentType="text/html;charset=UTF-8" %>
<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>    
<%@ page import="com.ibm.itim.webclient.util.*" %>
<%@ page import="com.ibm.itim.util.I18NMessage" %> 
<%@ page import="com.ibm.itim.apps.*" %> 
<%@ page import="com.ibm.itim.logging.SystemLog" %>
<%@ page import="com.ibm.itim.common.properties.PropertiesManager" %>
<%@ page import="com.ibm.itim.dataservices.model.system.SystemRole" %>


<%-- The main page containing content pages displayed after the user 
     has logged in.  Other pages are included as tables inside of this 
     page, with the exception of the organization tree. --%>

<%

  String UI_PROPERTIES = "enrole.ui";
  String BUILD_VERSION = "enrole.build.version";
  String buildVersion = "0000";

  Locale locale = (Locale)session.getAttribute("locale");
  if (locale == null) {
      locale = LocaleUtil.getLocale(request);
  if(locale == null)
		locale = request.getLocale();
  if (locale == null)
		locale = Locale.US;
  }
  
  // check that user is logged in
  String fromLogin = (String)request.getAttribute("fromLogin");
  boolean isFromLogin = (fromLogin != null) && fromLogin.equals("true");
  I18NMessage i18NMessage = new I18NMessage(locale, I18NMessage.ERRORMESSAGES_BUNDLE);
  if ((!isFromLogin) && session.isNew()) {
	  String message = i18NMessage.getMessage("main.jsp.sessionTimeout");
	  request.setAttribute("message", message);
	  session.invalidate();
%>
    <jsp:forward page="/logon"/>
<%
  } else {
    // if indicated, set the http headers to disable caching 
    String target = request.getParameter("target");
    if ((target != null) && (target.length() > 0) && (target.charAt(target.length()-1) == '0')) {
      response.setHeader("Cache-Control", "no-cache");
      response.setHeader("Pragma", "no-cache");
      response.setDateHeader("Expires", 0);
      System.err.println("main.jsp, no-cache");
    } else {
      // otherwise set it to expire after 60 seconds
      response.setDateHeader("Expires", 60);
    }
	
	UserAuthInfo userAuthInfo = UserAuthHelper.getUserAuthInfo(request);    	
	int systemRoleCat = userAuthInfo.getSystemRoleCategory();
	if (systemRoleCat < SystemRole.SYSTEMADMIN_CATEGORY) {
		String message = i18NMessage.getMessage("com.ibm.itim.apps.ejb.organization.ACCESS_DENIED");
		request.setAttribute("message", message);
	  	session.invalidate();
%>
	<jsp:forward page="/logon"/>
<%
    } else {
    ResourceBundle labels = ResourceBundle.getBundle(I18NMessage.LABEL_BUNDLE,
            locale);
    String title = labels.getString("frameTitle");
    
    I18NMessage messages = new I18NMessage(locale, I18NMessage.MESSAGE_BUNDLE);
    //ResourceBundle messages = ResourceBundle.getBundle(I18NMessage.MESSAGE_BUNDLE,
    //        locale);
    try {
        buildVersion = PropertiesManager.gInstance ().getProperty (
            UI_PROPERTIES, BUILD_VERSION);
        } catch (IOException ioe) {}

    String[] args = new String[]{buildVersion};
    String copyright = messages.getMessage("copyright",args);
	String path = labels.getString ("youAreHere") + " : " + UIContext.getPathBase(request);
	String USER_ID = labels.getString("userName");
%>
<!-- Copyright (c) 2000 by Access360. All Rights Reserved.-->
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="expires" content="0">
    <meta http-equiv="cache-control" content="no-cache">
    <link rel="stylesheet" 
          href="<%= locale.toString() %>/Styles.css" 
          type="text/css" title="Styles">
    <script language="JavaScript" src="script_library.js"></script>
    <script language="JavaScript" src="image_cache.js"></script>
    <script language="JavaScript" src="help.js"></script>
    <title>
      <%= title %>
    </title>
  </head>
  <body bgcolor="white" leftmargin="0" topmargin="0" rightmargin="0" 
		marginwidth="0"	onLoad="javascript:displayMessage(document);"
		onUnload="javascript:closePopups()">
    <table width=100% cellpadding=0 cellspacing=0 border="0">

    <jsp:include page="/main_menu" flush="true"/>

    <!-- Top Header Row -->
    <tr>
      <td class="topheader">
        <table cellpadding="0" cellspacing="0" border="0" width="100%">
	  <tr class="loginname">
	    <!-- Login Name -->
	    <td class="pathfinal" align="right">
			  <img src="images/pixel.gif" border="0" width="1" height="20">
	      <font bgcolor="#cccc99"><%=USER_ID%>:</font>&nbsp;
                <%=((UserAuthInfo)session.getAttribute(UserAuthHelper.USER_AUTH_INFO)).getUserID()%>
	    </td>
	  </tr>
	</table>
      </td>
    </tr>
    <tr>
        <td>
    <!-- Content area -->
    <jsp:include page="/app_processor" flush="true"/>
        </td>
    </tr>
    <tr>
        <td>
            <!-- Copyright notice -->
	        <table width="100%" border="0" cellpadding="0" cellspacing="0">
                <tr>
                    <td width="100%" height="9" bgcolor="cccc99"><img src="images/pixel.gif" width="1" height="9" border="0"/></td>
	            </tr>
                <tr>
                    <td class="copyright">
	                    <%=copyright%>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    </table>
    <!-- script to handle the enter on search -->
    				<script language="JavaScript1.2">
    								var form = getForm(document);
    								if(form) {
                                            	if (form.elements['search_param']){
    							form.elements['search_param'].focus();
                                            		form.elements['search_param'].onkeypress=onEnterSearch;
    									}
                                            }
                                </script>
</body>
</html>
<%
	}
}  
%>


