<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="javax.ejb.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.rmi.*" %>
<%@ page import="javax.naming.*" %>
<%@ page import="javax.servlet.*" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="com.ibm.itim.webclient.util.LocaleUtil" %>
<%@ page import="com.ibm.itim.logging.SystemLog" %>
<%@ page import="com.ibm.itim.webclient.util.*" %>
<%@ page import="com.ibm.itim.webclient.home.ConfigurationTabs" %>
<%@ page import="com.ibm.itim.authentication.AuthenticationException" %>
<%@ page import="com.ibm.itim.authentication.*" %>
<%@ page import="com.ibm.itim.apps.UserAuthInfo" %>
<%@ page import="com.ibm.itim.apps.exception.*" %>
<%@ page import="com.ibm.itim.common.formModel.*" %>
<%@ page import="com.ibm.itim.common.properties.PropertiesManager" %>
<%@ page import="com.ibm.itim.apps.ejb.domain.*" %>
<%@ page import="com.ibm.itim.apps.ejb.workflow.designer.*" %>
<%@ page import="com.ibm.itim.dataservices.model.*" %>
<%@ page import="com.ibm.itim.util.*" %>
<%@ page import="java.lang.reflect.*" %>
<%@ page import="com.ibm.itim.util.I18NMessage" %>
<%
	// Labels and Messages constant
	String DEFINE_WORKFLOW = "DEFINE_WORKFLOW";
    String DEFINE_OPERATIONS = "DEFINE_OPERATIONS";
    String ENTITY_TYPES = "ENTITY_TYPES";
    String ADD_DELETE_MODIFY_ENTITY_OPERATION = "ADD_DELETE_MODIFY_ENTITY_OPERATION";
    String ADD_DELETE_MODIFY_ENTITY_TYPE_OPERATION = "ADD_DELETE_MODIFY_ENTITY_TYPE_OPERATION";
    String NEW_OPERATION_LABEL ="NEW_OPERATION_LABEL";
    String OPERATION_NAME_COLUMN ="OPERATION_NAME_COLUMN";
    String OPERATION_TYPE_COLUMN ="OPERATION_TYPE_COLUMN";
    String OPERATION_LEVEL_COLUMN = "OPERATION_LEVEL_COLUMN";
    String OPERATION_TYPE_SYSTEM = "OPERATION_TYPE_SYSTEM";
    String OPERATION_TYPE_USER = "OPERATION_TYPE_USER";
    String OPERATION_LEVEL_GLOBAL = "OPERATION_LEVEL_GLOBAL";
    String OPERATION_LEVEL_ENTITY = "OPERATION_LEVEL_ENTITY";
    String OPERATION_LEVEL_ENTITY_TYPE = "OPERATION_LEVEL_ENTITY_TYPE";
    String OPERATION_LEVEL_ENTITY_OVERRIDE = "OPERATION_LEVEL_ENTITY_OVERRIDE";
    String ENTER_OPERATION_NAME = "ENTER_OPERATION_NAME";
    String ADD = "ADD";
    String DELETE = "DELETE";
    String DONE = "DONE";

    String SERVICE_CONFIG = "serviceConfig";
	String UI_CUSTOMIZE = "uiCustomize";
	String SYSADMIN = "sysAdmin";
	String ENTITY_CONFIG = "entityConfig";
    String ENTITY_TYPE_CONFIG = "entityTypeConfig";
	String PROPERTIES = "properties";
	String POLICY_JOIN = "policyJoin";
	String CHALLENGE_RESPONSE = "challengeResponse";
    String UI_PROPERTIES = "enrole.ui";
    String BUILD_VERSION = "enrole.build.version";
    String buildVersion = "0000";


  Locale localeObj = (Locale)session.getAttribute("locale");
  if (localeObj == null) {
      localeObj = LocaleUtil.getLocale(request);
  if(localeObj == null)
		localeObj = request.getLocale();
  if (localeObj == null)
		localeObj = Locale.US;
  }
  String localeDir = localeObj.toString();
  if (localeDir.equals("en_US")) {  //we don't have this en_US
        localeDir = "en";
  }
  // check that user is logged in
  String fromLogin = (String)request.getAttribute("fromLogin");
  boolean isFromLogin = (fromLogin != null) && fromLogin.equals("true");
  if ((!isFromLogin) && session.isNew()) {
	  I18NMessage i18NMessage = new I18NMessage(localeObj, I18NMessage.ERRORMESSAGES_BUNDLE);
	  String message = i18NMessage.getMessage("main.jsp.sessionTimeout");
	  request.setAttribute("message", message);
	  session.invalidate();
%>
    <jsp:forward page="/logon"/>
<%
  } else {
    response.setHeader("Cache-Control", "no-cache");
    response.setHeader("Pragma", "no-cache");
    response.setDateHeader("Expires", 0);
    I18NMessage i18NLabel = new I18NMessage(localeObj, I18NMessage.LABEL_BUNDLE);
    I18NMessage i18NMessage = new I18NMessage(localeObj, I18NMessage.MESSAGE_BUNDLE);

    // directory for images and other resources
    ResourceBundle labels = ResourceBundle.getBundle(I18NMessage.LABEL_BUNDLE,
            localeObj);
    String title = labels.getString("frameTitle");
    I18NMessage messages = new I18NMessage(localeObj, I18NMessage.MESSAGE_BUNDLE);


    try {
        buildVersion = PropertiesManager.gInstance ().getProperty (
            UI_PROPERTIES, BUILD_VERSION);
        } catch (IOException ioe){}

    String[] args = new String[]{buildVersion};
    String copyright = messages.getMessage("copyright",args);
	String path = labels.getString ("youAreHere") + " : " + UIContext.getPathBase(request);
	String USER_ID = labels.getString("userName");
    	
	UserAuthInfo userAuthInfo = UserAuthHelper.getUserAuthInfo(request);    	
	//	Calling EJBFactory.getHome(...) instead of context lookup. 
	//	For more info ref. devtrack S12664 
	EntityManagerHome entityManagerHome =
			(EntityManagerHome)EJBFactory.getHome("enroleejb.EntityManagerHome",
													com.ibm.itim.apps.ejb.domain.EntityManagerHome.class);
	EntityManager entityManager = entityManagerHome.create();
    String language = LocaleUtil.getLocale(request).toString();
    String languageDirection = I18NMessage.getLanguageDirection(i18NLabel);
    String message = null;
    SystemLog log = SystemLog.getInstance();
     
    // Get variables from request
    String action = request.getParameter("command");
    //System.out.println("%%%%op  command = " + action);
	String profileName = request.getParameter("profileName");
    String objName = request.getParameter("entityName");
    String ldapname = request.getParameter("ldapname");
    String category = request.getParameter("category");
    //System.out.println("%%%% operation request category = " + category);
    String categoryLabel = category;
    //System.out.println("%%%% operation request category label = " + category);
    if (categoryLabel != null) {
        if (categoryLabel.equalsIgnoreCase(i18NLabel.getMessage("ObjectProfileCategory.Person")))
	        category = ObjectProfileCategory.PERSON;
        else if (categoryLabel.equalsIgnoreCase(i18NLabel.getMessage("ObjectProfileCategory.BPPerson")))
	        category = ObjectProfileCategory.BPPERSON;
        else if (categoryLabel.equalsIgnoreCase(i18NLabel.getMessage("ObjectProfileCategory.Account")))
	        category = ObjectProfileCategory.ACCOUNT;
        else if (categoryLabel.equalsIgnoreCase(i18NLabel.getMessage("ObjectProfileCategory.Global")))
	        category = ObjectProfileCategory.GLOBAL;
    }
    //System.out.println("%%%% operation category after translation = " + category);
    String rdnName = request.getParameter("rdnName");
    String searchAttribute = request.getParameter("searchAttribute");
    String enroleMapStr = request.getParameter("enroleMap");
	String customMapStr = request.getParameter("customMap");
	String messageStr = request.getParameter("message");
    String mode = request.getParameter("mode");
    String operationAction = request.getParameter("operationAction");
    if (operationAction == null) operationAction = "";
    //System.out.println("%%%% operationAction = " + operationAction);
    String operationName = request.getParameter("operationName");
    if (operationName == null) operationName = "";
    //System.out.println("%%%% operationName = " + operationName);

    // if variables are null, get then from the session
    if (profileName == null) profileName = (String) session.getAttribute("profileName");
    //System.out.println("%%%% profileName = " + profileName);
    if (category == null) {
        category = (String) session.getAttribute("category");
        //System.out.println("%%%% operation session category = " + category);
        if (category != null) 
            categoryLabel = i18NLabel.getMessage("ObjectProfileCategory."+category);
        else
            categoryLabel = null;
    }
    //System.out.println("%%%% final operation category = " + category);
    //System.out.println("%%%% final operation category label = " + categoryLabel);
    if (mode == null) mode = (String) session.getAttribute("mode");
    //System.out.println("%%%% mode = " + mode);
    if (action == null) action = (String) session.getAttribute("command");
    //System.out.println("%%%% command = " + action);

    // save variables in session
    if (action != null) session.setAttribute("command",action);
    if (profileName != null) session.setAttribute("profileName",profileName);
    if (objName != null) session.setAttribute("entityName",objName);
    if (ldapname != null) session.setAttribute("ldapname",ldapname);
    if (category != null) session.setAttribute("category",category);
    if (rdnName != null) session.setAttribute("rdnName",rdnName);
    if (searchAttribute != null) session.setAttribute("searchAttribute",searchAttribute);
    if (enroleMapStr != null) session.setAttribute("enroleMap",enroleMapStr);
    if (customMapStr != null) session.setAttribute("customMap",customMapStr);
    if (messageStr != null) session.setAttribute("message",messageStr);
    if (mode != null) session.setAttribute("mode",mode);

    /** check if this is entity or entity type mode **/
	boolean entityMode = false;
	boolean entityTypeMode = false;
    if (mode != null) {
	    if (mode.equalsIgnoreCase("entity"))
			entityMode = true;
		else if (mode.equalsIgnoreCase("entitytype"))
			entityTypeMode = true;
	}

    ObjectProfile objectProfile = null;
    ObjectProfileCategory objectProfileCategory = null;
    ObjectProfileOperation objectProfileOperation = null;
    DistinguishedName dn = null;
    DistinguishedName tenantDN = null;
    String tenantDNstr = null;
    WfDesignerManagerBean workflowBean = new WfDesignerManagerBean();
    
    int i = 0;
    int j = 0;

    /**
     ** Delete operations and their associated workflow and update the entity object
     **/
    if (operationAction.equalsIgnoreCase("delete")) {
        try {
            String[] operationNames = request.getParameterValues("operationsCB");
            boolean deletedOperations = false;
            if (operationNames != null && operationNames.length>0) {
                for (i=0; i<operationNames.length; i++) {
                    //System.out.println("%%%% operation entries to be deleted = " + operationNames[i]);
                }
                if (entityMode) {
                    //System.out.println("%%%% entity mode");
                    if (profileName !=null){
                        objectProfile = entityManager.getDetails(userAuthInfo, profileName);
                        /** Delete entity operations and update the entity object **/
                        if (objectProfile != null) {
                            for (i=0; i < operationNames.length; i++) {
                                objectProfileOperation = objectProfile.getOperation(operationNames[i]);
                                //System.out.println("objectProfileOperation object = " + objectProfileOperation);
                                if (objectProfileOperation != null && objectProfileOperation.isSystem()) {
                                    //System.out.println("system-defined operation cannot be deleted : " + objectProfileOperation.getName());
                                } else if (objectProfileOperation != null){
                                    dn = objectProfileOperation.getDefinitionDN();
                                    //System.out.println("%%%% dn of operation workflow to be deleted = " + dn);
                                    if (dn != null) workflowBean.removeWfDef(userAuthInfo,dn);
                                    //System.out.println("%%%% ready to delete entity operation = " + operationNames[i]);
                                    objectProfile.removeOperation(operationNames[i]);
                                    deletedOperations = true;
                                }
                            }
                            if (deletedOperations) entityManager.modifyEntity(userAuthInfo, objectProfile);
                        }
                    }
	    	
                } else if (entityTypeMode) {
                    //System.out.println("%%%% entity type mode");
                    if (category !=null){
                        tenantDNstr = userAuthInfo.getTenantDN();
                        //System.out.println("%%%% tenantDNstr = " + tenantDNstr);
                        if (tenantDNstr != null && tenantDNstr.length()>0) tenantDN = new DistinguishedName(tenantDNstr);
                        if (tenantDN != null){
                            objectProfileCategory = (ObjectProfileCategory)CategoryTable.getInstance(tenantDN).getCategory(category);
                            /** Delete entity type operations and update the entity type object **/
                            if (objectProfileCategory != null) {
                                for (i=0; i < operationNames.length; i++) {
                                    objectProfileOperation = objectProfileCategory.getOperation(operationNames[i]);
                                    if (objectProfileOperation != null && objectProfileOperation.isSystem()){
                                        //System.out.println("system-defined operation cannot be deleted : " + objectProfileOperation.getName());
                                    }else if (objectProfileOperation != null){
                                        dn = objectProfileOperation.getDefinitionDN();
                                        if (dn != null) workflowBean.removeWfDef(userAuthInfo,dn);
                                        objectProfileCategory.removeOperation(operationNames[i]);
                                        deletedOperations = true;
                                    }
                                }
                                if (deletedOperations) CategoryTable.getInstance(tenantDN).updateCategory((ObjectProfileCategory)objectProfileCategory);
                            }
                        }
                    }

                }
            } else {
                //System.out.println("%%%% No operations selected to delete!");
            }
        }
        catch(RemoteException re)
        {
            throw new AppProcessingException(re.getMessage());
        }catch(com.ibm.itim.dataservices.model.ObjectNotFoundException onfe)
        {
            throw new AppProcessingException(onfe.getMessage());
        }catch(ModelException me)
        {
            throw new AppProcessingException(me.getMessage());
        }catch(AppProcessingException ape) {
            message = ape.getMessage(localeObj);
	        log.logError(this, ape.getMessage(), ape);
        }catch(Exception e) {
            log.logError(this, e.getMessage(), e);
        }

    }

    String profile_dn = "";
    String opName = null;
    objectProfileOperation = null;
    Vector entityOpNameVector = new Vector();
    Vector entityOpTypeVector = new Vector();
    Vector entityOpLevelVector = new Vector();
    Vector entityTypeOpNameVector = new Vector();
    Vector entityTypeOpTypeVector = new Vector();
    Vector entityTypeOpLevelVector = new Vector();
    String entityOpName[] = null;
    String entityOpType[] = null;
    String entityOpLevel[] = null;
    String entityTypeOpName[] = null;
    String entityTypeOpType[] = null;
    String entityTypeOpLevel[] = null;

    /***********
    // testcase
    ************/
    //String entityOpName[] = {"Certify","Self-Register"};
    //String entityTypeOpName[] = {"Add", "Modify", "Delete", "Suspend", "Restore", "Transfer"};
    //String entityOpType[] = {"user-defined","user-defined"};
    //String entityTypeOpType[] = {"system-defined", "system-defined", "system-defined", "system-defined", "system-defined", "system-defined"};
    //String entityOpLevel[] = {"entity","entity"};
    //String entityTypeOpLevel[] = {"entity type", "entity type", "entity type", "entity type", "entity type", "entity type"};
    
    i = 0;
    j = 0;
    
    // get entity and entity type operations for the specified profileName and
    // build the entity operation arrays to hold the operation name, type, and level info
    if (entityMode) {
        // get entity operations
        if (profileName != null)
		    objectProfile = entityManager.getDetails(userAuthInfo, profileName);
        if (objectProfile != null){
            profile_dn = objectProfile.getDistinguishedName().toString();
            Collection entityOperationNames = objectProfile.getOperationNames();
            if (entityOperationNames != null) {
				if (entityOperationNames.isEmpty()) {
					//System.out.println("%%%% No entity operations found for entity " + profileName);

				} else {
					//System.out.println("%%%% entityOperationName collection size is " + entityOperationNames.size());
				}
				Iterator itr = entityOperationNames.iterator();
				while (itr.hasNext())
				{
					opName = (String)itr.next();
					objectProfileOperation = objectProfile.getOperation(opName);
					entityOpNameVector.add(objectProfileOperation.getName());
					if (objectProfileOperation.isSystem())
						entityOpTypeVector.add(i18NLabel.getMessage(OPERATION_TYPE_SYSTEM));
					else 
						entityOpTypeVector.add(i18NLabel.getMessage(OPERATION_TYPE_USER));
					entityOpLevelVector.add(i18NLabel.getMessage(OPERATION_LEVEL_ENTITY));
					//System.out.println("%%%% entity operation " + i + " = " + objectProfileOperation.getName() + " is System? " + objectProfileOperation.isSystem());
					i++;
				}
			}
        }
        // get entity type operations
        tenantDNstr = userAuthInfo.getTenantDN();
        if (tenantDNstr != null && tenantDNstr.length()>0) tenantDN = new DistinguishedName(tenantDNstr);
        if (category != null && tenantDN != null) {
		    category = (category.equals(ObjectProfileCategoryConstant.SYSTEM_USER))?
			    ObjectProfileCategoryConstant.ACCOUNT:category;
            objectProfileCategory = CategoryTable.getInstance(tenantDN).getCategory(category);
		}
        if (objectProfileCategory != null){
            Collection entityTypeOperationNames = objectProfileCategory.getOperationNames();
            if (entityTypeOperationNames != null) {
				if (entityTypeOperationNames.isEmpty()) {
					//System.out.println("%%%% No entity type operations found for entity type " + category);
				} else {
					//System.out.println("%%%% entityTypeOperationName collection size is " + entityTypeOperationNames.size());
				}
				Iterator itr = entityTypeOperationNames.iterator();
				while (itr.hasNext())
				{
					opName = (String)itr.next();
					objectProfileOperation = objectProfileCategory.getOperation(opName);
					// if the entity has overridden this entity type operation,
					// then don't add it to the name array but change the level to entity override
					//
					boolean duplicate = false;
					for (int k=0; k<entityOpNameVector.size(); k++) {
							String existingOpName = (String)entityOpNameVector.get(k); 
							if (existingOpName.equalsIgnoreCase(objectProfileOperation.getName())) {
								entityOpLevelVector.set(k,i18NLabel.getMessage(OPERATION_LEVEL_ENTITY_OVERRIDE));
								duplicate=true;
							}
					}
					if (!duplicate) {
						entityOpNameVector.add(objectProfileOperation.getName());
						if (objectProfileOperation.isSystem())
							entityOpTypeVector.add(i18NLabel.getMessage(OPERATION_TYPE_SYSTEM));
						else 
							entityOpTypeVector.add(i18NLabel.getMessage(OPERATION_TYPE_USER));
						entityOpLevelVector.add(i18NLabel.getMessage(OPERATION_LEVEL_ENTITY_TYPE));
						//System.out.println("%%%% entity type operation " + i + " = " + opName);
					}
					i++;
				}
			}
        }
        
        // copy vectors into arrays
        entityOpName = new String [entityOpNameVector.size()];
		entityOpType = new String [entityOpTypeVector.size()];
		entityOpLevel = new String [entityOpLevelVector.size()];
        entityOpNameVector.copyInto(entityOpName);
        entityOpTypeVector.copyInto(entityOpType);
        entityOpLevelVector.copyInto(entityOpLevel);
    }

    // get entity type operations
    if (entityTypeMode) {
        tenantDNstr = userAuthInfo.getTenantDN();
        //System.out.println("%%%% tenantDNstr = " + tenantDNstr);
        if (tenantDNstr != null && tenantDNstr.length()>0) tenantDN = new DistinguishedName(tenantDNstr);
        if (category != null && tenantDN != null)
            objectProfileCategory = CategoryTable.getInstance(tenantDN).getCategory(category);
        if (objectProfileCategory != null){
            Collection entityTypeOperationNames = objectProfileCategory.getOperationNames();
            if (entityTypeOperationNames != null) {
				if (entityTypeOperationNames.isEmpty()) {
					//System.out.println("%%%% No entity type operations found for entity type " + category);
				} else {
					/*int opCount = entityTypeOperationNames.size ();
					entityTypeOpName = new String [opCount];
					entityTypeOpType = new String [opCount];
					entityTypeOpLevel = new String [ opCount];*/
				}
				//System.out.println("%%%% entityTypeOperationName collection size is " + entityTypeOperationNames.size());
				Iterator itr = entityTypeOperationNames.iterator();
				while (itr.hasNext())
				{
					opName = (String)itr.next();
                    objectProfileOperation = objectProfileCategory.getOperation(opName);
                    if (category.equalsIgnoreCase("Global") && objectProfileOperation.isSystem()) {
                        // hide the operation
                        j++;
                    } else {
                        //display the operation
                        entityTypeOpNameVector.add(objectProfileOperation.getName());
					    if (objectProfileOperation.isSystem())
						    entityTypeOpTypeVector.add(i18NLabel.getMessage(OPERATION_TYPE_SYSTEM));
					    else 
						    entityTypeOpTypeVector.add(i18NLabel.getMessage(OPERATION_TYPE_USER));
                        entityTypeOpLevelVector.add(i18NLabel.getMessage(OPERATION_LEVEL_ENTITY_TYPE));
					    //System.out.println("%%%% entity type operation " + j + " = " + opName);
					    j++;
                    }
				}
			}
        }
        // copy vectors into arrays
		entityTypeOpName = new String [entityTypeOpNameVector.size()];
		entityTypeOpType = new String [entityTypeOpTypeVector.size()];
		entityTypeOpLevel = new String [entityTypeOpLevelVector.size()];
		entityTypeOpNameVector.copyInto(entityTypeOpName);
		entityTypeOpTypeVector.copyInto(entityTypeOpType);
        entityTypeOpLevelVector.copyInto(entityTypeOpLevel);
    }
    
     %>
 
<!-- Copyright (c) 2000 by Access360. All Rights Reserved.-->
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="expires" content="0">
    <meta http-equiv="cache-control" content="no-cache">
    <link rel="stylesheet" 
          href="<%= localeObj %>/Styles.css" 
          type="text/css" title="Styles">
    <script language="JavaScript" src="script_library.js"></script>
    <script language="JavaScript" src="image_cache.js"></script>
    <script language="JavaScript" src="help.js"></script>
    <title>
      <%= title %>
    </title>
  </head>
  <body bgcolor="white" leftmargin="0" topmargin="0" rightmargin="0" 
		marginwidth="0"	onLoad="javascript:displayMessage(document);">
    <table width=100% cellpadding=0 cellspacing=0 border="0">

    <jsp:include page="/main_menu" flush="true"/>

    <!-- Top Header Row -->
    <tr>
      <td class="topheader">
        <table cellpadding="0" cellspacing="0" border="0" width="100%">
	  <tr class="loginname">
	    <!-- Login Name -->
	    <td class="pathfinal" align="right">
			  <img src="images/pixel.gif" border="0" width="1" height="20">
	      <font bgcolor="#cccc99"><%=USER_ID%>:</font>&nbsp;
                <%=((UserAuthInfo)session.getAttribute(UserAuthHelper.USER_AUTH_INFO)).getUserID()%>
	    </td>
	  </tr>
	</table>
      </td>
    </tr>

<tr>
        <td> 
 
<table name="mainContentTable" cellpadding="0" cellspacing="0" border="0" width="100%">
<!-- For "You are here: path" bar - begin -->
<tr class="path" width="100%">
<td colspan="2" class="content" bgcolor="#e7e7cf">
<table border="0" cellspacing="0" cellpadding="0" height="100%" width="100%">

    <tr>
      <td height="1%" valign="top" colspan="3" bgcolor="#cccc99">
        <table name="pathTable" cellpadding="0" cellspacing="0" border="0" width="100%">
          <tr>
            <td background="images/bar_up_bg.gif" valign="top" height="10" colspan="2"><img height="10" width="6" border="0" src="images/bar_upper.gif"></td>
          </tr>

          <tr class="path">
            <td valign="left" width="1" height="16">
              <img src="images/pixel.gif"><img src="images/pixel.gif" width="1" height="20" border="0">
            </td>
            <td class="pathitem" valign="center" height="16" width="500" BGCOLOR="#e7e7cf">
<%
              if (languageDirection.equals(I18NMessage.LANGUAGE_DIRECTION_LTR)) {

			    if (entityTypeMode) {%>
                    <%=i18NLabel.getMessage("youAreHere")%>: <%=UIContext.getPathBase (request)%> &gt; <%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_TYPE_CONFIG)%> &gt;
                    <%=categoryLabel%> &gt; <span class="pathfinal"><%=i18NLabel.getMessage(DEFINE_OPERATIONS)%></span>
                <%} else if (entityMode) {%>
                    <%=i18NLabel.getMessage("youAreHere")%>: <%=UIContext.getPathBase (request)%> &gt; <%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_CONFIG)%> &gt;
                    <%=profileName%> &gt; <span class="pathfinal"><%=i18NLabel.getMessage(DEFINE_OPERATIONS)%></span>
                <%}
              }
              else if (languageDirection.equals(I18NMessage.LANGUAGE_DIRECTION_RTL)) {

                if (entityTypeMode) {%>
                    <span class="pathfinal"><%=i18NLabel.getMessage(DEFINE_OPERATIONS)%></span> &lt; <%=category%>
			        &lt; <%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_TYPE_CONFIG)%> &lt; <%=UIContext.getPathBase (request)%> :<%=i18NLabel.getMessage("youAreHere")%>
                <%} else if (entityMode) {%>
                    <span class="pathfinal"><%=i18NLabel.getMessage(DEFINE_OPERATIONS)%></span> &lt; <%=profileName%>
			        &lt; <%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_CONFIG)%> &lt; <%=UIContext.getPathBase (request)%> :<%=i18NLabel.getMessage("youAreHere")%>
                <%}
              }
%>
            </td>
          </tr>

          <tr>
            <td background="images/bar_lo_bg.gif" height="10" colspan="2" valign="top"><img height="10" width="6" border="0" src="images/bar_lower.gif"></td>
          </tr>
        </table>
      </td>
    </tr>

<!-- For "You are here: path" bar - end -->
<tr>
<td class="content" height="30"><img border="0" height="15" width="15" src="images/pixel.gif">
<%
        if (entityMode)
            out.println(i18NLabel.getMessage(ADD_DELETE_MODIFY_ENTITY_OPERATION));
        else
            out.println(i18NLabel.getMessage(ADD_DELETE_MODIFY_ENTITY_TYPE_OPERATION));
    %>
   
</td>
<td align="right"><img src="images/pixel.gif" border="0" width="5" height="1">
<a href="
<%if (entityMode) out.println(HelpUtil.getJavaScriptHelpMethod (pageContext.getServletContext(), request, "CONFIGURATION_ENTITIES_OPERATIONS"));
else if (entityTypeMode) out.println(HelpUtil.getJavaScriptHelpMethod (pageContext.getServletContext(), request, "CONFIGURATION_ENTITY_TYPE_OPERATIONS"));%>
"><img name="helpquestion" src="images/question.gif" width="16" height="16" hspace="2" border="0" onmouseover="document.images['helpquestion'].src='images/question_f2.gif';" onmouseout="document.images['helpquestion'].src='images/question.gif';"></a>
</td>
</tr>
</table>
</td>
</tr>
   
 
<form name="body">
<input type="hidden" name="target">
<input type="hidden" name="UIContext" value="configuration">
<input type="hidden" name="operation" value="">
<input type="hidden" name="tab_index" value="">
<tr>
<td width="5">&nbsp;&nbsp;</td><td valign="top">
<table border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<br>
</td>
</tr>
<tr>
<td>

    <table cellpadding="0" cellspacing="0" width="100%" border="0">
      <tr>
      <td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('service_profiles_servlet')"><%=i18NLabel.getMessage(SERVICE_CONFIG)%></a></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('form_designer')"><%=i18NLabel.getMessage(UI_CUSTOMIZE)%></a></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
	<table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('system_role_disp','','admin')"><%=i18NLabel.getMessage(SYSADMIN)%></a></td>
	  </tr>
	</table>
      </td>
      
     <%if (entityTypeMode) {%>  
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="activetab"><font style="font-size: 8pt; color: #000000; font-weight: bold;"><%=i18NLabel.getMessage(ENTITY_TYPE_CONFIG)%></font></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight : bold;" href="javascript:switchToSelectedTabs('entity_list')"><%=i18NLabel.getMessage(ENTITY_CONFIG)%></a></td>
	  </tr>
	</table>
      </td>
      <%}else{%>
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('entityTypeConfig.jsp')"><%=i18NLabel.getMessage(ENTITY_TYPE_CONFIG)%></a></td>
          </tr>
        </table>
      </td>

      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="activetab"><font style="font-size: 8pt; color: #000000; font-weight : bold;"><%=i18NLabel.getMessage(ENTITY_CONFIG)%></font></td>
	  </tr>
	</table>
      </td>

      <%}%>
      
      <td class="tabspacer"></td>
      <td align="center">
	<table cellspacing="0" width="100%" border="0">
	  <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('system_properties')"><%=i18NLabel.getMessage(PROPERTIES)%></a></td>
	  </tr>
	</table>
      </td>
      <td class="tabspacer"></td>
      <td align="center">
      	<table cellspacing="0" width="100%" border="0">
      	  <tr align="center">
      	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('policy_join_directives')"><%=i18NLabel.getMessage(POLICY_JOIN)%></a></td>
      	  </tr>
      	</table>
            </td>
      <td class="tabspacer"></td>
      <td align="center">
      	<table cellspacing="0" width="100%" border="0">
      	  <tr align="center">
		<td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('challenge_response_config')"><%=i18NLabel.getMessage(CHALLENGE_RESPONSE)%></a></td>
      	  </tr>
      	</table>
            </td>
      <td class="tabspacer"></td>
      </tr>
    </table>
  </td>
</tr>
</form>

<tr width="100%">
<td class="content" bgcolor="#e7e7cf"><img border="0" height="5" width="15" src="images/pixel.gif"><br>
</td>
</tr>
<tr bgcolor="e7e7cf">
<td>

<% 

String tabIndex = request.getParameter("tab_index");
String[] locale = { LocaleUtil.getLocale(request).getLanguage(), LocaleUtil.getLocale(request).getCountry() };
String sessionId = session.getId();

// if no tab index is found in the request, then default to tab '0'
if (tabIndex == null || tabIndex.equals("")) {
      tabIndex = "3";
}
%>

 
<SCRIPT language=JavaScript>
	<!--	
	var message = null;
	<%message = request.getParameter("message");
	if (message != null && !message.equals(""))
	{%>
	message = "<%=message%>";
	<%}%>
    
	function done() {
        <% if (entityMode) { %>
            document.forms['frmOpMain'].elements['target'].value = "entityConfig.jsp";
            <%} else { %> 
            document.forms['frmOpMain'].elements['target'].value = "entityTypeConfig.jsp";
        <%}%>
        document.forms['frmOpMain'].elements['action'] = "main.jsp";
        document.forms['frmOpMain'].elements['command'].value = "<%=action%>";
		document.forms['frmOpMain'].elements['profile_dn'].value = "<%=profile_dn%>";
        document['frmOpMain'].submit();
        //window.close();
	}
    
    function addOperation() {
        document.forms['frmOpMain'].elements['operationAction'].value = "add";
        var opname = document.forms['frmOpMain'].elements['operation'].value;
        if (opname == null || opname == "")
			alert("<%=i18NLabel.getMessage(ENTER_OPERATION_NAME)%>");
		else {
            document.forms['frmOpMain'].elements['operationName'].value = opname;
            document.forms['frmOpMain'].elements['action'] = "workflow.jsp";
            document.forms['frmOpMain'].elements['profile_dn'].value = "<%=profile_dn%>";
            document['frmOpMain'].submit();
        }
    }
    
    function modifyOperation(operationname) {
        document.forms['frmOpMain'].elements['operationAction'].value = "modify";
        document.forms['frmOpMain'].elements['operationName'].value = operationname;
        document.forms['frmOpMain'].elements['action'] = "workflow.jsp";
        document.forms['frmOpMain'].elements['profile_dn'].value = "<%=profile_dn%>";
        document['frmOpMain'].submit();
    }


    function deleteOperation() {
        document.forms['frmOpMain'].elements['operationAction'].value = "delete";
        document.forms['frmOpMain'].elements['action'] = "operations.jsp";
        document['frmOpMain'].submit();
    }

	function cancel() {
        <% if (entityMode) { %>
            document.forms['frmOpMain'].elements['action'] = "entityConfig.jsp";
            <%} else { %> 
            document.forms['frmOpMain'].elements['action'] = "entityTypeConfig.jsp";
        <%}%>
        document['frmOpMain'].submit();
		//window.close();
	}
    
        
     //-->
</script>

<!-- JavaScript for Expanding Menus -->
<STYLE type=text/css>.magellanlink {
	COLOR: #FFF; FONT-FAMILY: arial, helvetica, geneva, swiss, sunsans-regular; FONT-SIZE: 9pt; TEXT-DECORATION: underline
}
.magellanlinkhi {
	COLOR: blue; FONT-FAMILY: arial, helvetica, geneva, swiss, sunsans-regular; FONT-SIZE: 9pt; TEXT-DECORATION: underline
}
.magellandiv {
	MARGIN-BOTTOM: 3px
}
</STYLE>

<!--- <center> --->
<form action="" method="POST" enablecab="Yes" name="frmOpMain">
<input type="hidden" name="profileName" value="<%=profileName%>">
<input type="hidden" name="command" value="<%=action%>">
<input type="hidden" name="tab_index" value="3">
<input type="hidden" name="target" value="">
<input type="hidden" name="category" value="<%=category%>">
<input type="hidden" name="mode" value="<%=mode%>">
<input type="hidden" name="operationAction" value="<%=operationAction%>">
<input type="hidden" name="operationName" value="<%=operationName%>">
<input type="hidden" name="profile_dn" value="<%=profile_dn%>">



<font class=content><%=i18NLabel.getMessage(NEW_OPERATION_LABEL)%></font><input type="text" name="operation">
<a href="javascript:addOperation();"><img name="buttonadd" src="<%=language%>/images/buttonadd.gif" hspace="2" alt="<%=i18NLabel.getMessage(ADD)%>" border="0" onmouseover="document.images['buttonadd'].src='<%=language%>/images/buttonadd_f2.gif';" onmouseout="document.images['buttonadd'].src='<%=language%>/images/buttonadd.gif';"></a>
<br>
 
 
<!--
<table cellpadding=0 cellspacing=0 border=1 width="100%">
    	
    <tr class="formtable">
	<td class="formtable">
-->
    
 <table width="100%" border="0" cellspacing="1" cellpadding="3">
<input type="hidden" name="sortBy"><input type="hidden" name="sortOrder"><input value="0" type="hidden" name="pageNo">
<tr><br>
<td width="12"><img src="images/pixel.gif" width="12" height="20" border="0"></td><td width="100%" colspan="4">


<table align="left" bordercolordark="white" bordercolor="lightgrey" width="100%" border="1" cellspacing="0" cellpadding="0">
<tr>
<td bgcolor="e7e7cf" class="tablelabel" nowrap="true">
								&nbsp;	
	            </td><td bgcolor="e7e7cf" class="tablelabel" nowrap="true"><%=i18NLabel.getMessage(OPERATION_NAME_COLUMN)%>
								&nbsp;	
	            </td><td bgcolor="e7e7cf" class="tablelabel" nowrap="true"><%=i18NLabel.getMessage(OPERATION_TYPE_COLUMN)%>
								&nbsp;	
	            </td><td bgcolor="e7e7cf" class="tablelabel" nowrap="true"><%=i18NLabel.getMessage(OPERATION_LEVEL_COLUMN)%>
								&nbsp;	
	            </td>
</tr>

<%
    if (entityMode) {
        if (entityOpName != null && entityOpName.length>0) {
            for (i=0; i<entityOpName.length; i++) {
                String escapedEntityOpName = entityOpName[i];
                escapedEntityOpName = BaseServlet.escapePercentInURL(escapedEntityOpName);
                %>
                <tr class="data">
                <td width="5"><input name="operationsCB" type="checkbox" value="<%=entityOpName[i]%>"></td>
                <TD class="tablecell"><A HREF="workflow.jsp?operationName=<%=escapedEntityOpName%>+&operationAction=modify"><%=entityOpName[i]%></A>&nbsp;</TD>
                <td class="tablecell"><%=entityOpType[i]%>&nbsp;</TD>
    		    <td class="tablecell"><%=entityOpLevel[i]%>&nbsp;</TD>
                </TR>
<%		    }
        }
        
    } else if (entityTypeMode) {
        if (entityTypeOpName != null && entityTypeOpName.length>0) {
            for (i=0; i<entityTypeOpName.length; i++) {
                %>
                <tr class="data">
                <td width="5"><input name="operationsCB" type="checkbox" value="<%=entityTypeOpName[i]%>"></td>
                <TD class="tablecell"><A HREF="workflow.jsp?operationName=<%=entityTypeOpName[i]%>+&operationAction=modify"><%=entityTypeOpName[i]%></A>&nbsp;</TD>
                <td class="tablecell"><%=entityTypeOpType[i]%>&nbsp;</TD>
    		    <td class="tablecell"><%=entityTypeOpLevel[i]%>&nbsp;</td>
                </TR>
<%		    }
        }
	}
    %>
</table>
   					
                            
                            
    </td>
	</tr>
</table>

<tr>
	<td>
		<table cellpadding=1 cellspacing=0 border=0 width="100%" class="formtable">
		<tr>
			<td height="30" align="center">
			<table border="0" cellpadding="0" cellspacing="0" >
				<td>
                <a href="javascript:deleteOperation();"><img name="buttonDelete" src="<%=language%>/images/buttondelete.gif" hspace="2" alt="<%=i18NLabel.getMessage(DELETE)%>" border="0" onmouseover="document.images['buttonDelete'].src='<%=language%>/images/buttondelete_f2.gif';" onmouseout="document.images['buttonDelete'].src='<%=language%>/images/buttondelete.gif';"></a>
                <a href="javascript:done();"><img name="buttonDone" src="<%=language%>/images/buttondone.gif" hspace="2" alt="<%=i18NLabel.getMessage(DONE)%>" border="0" onmouseover="document.images['buttonDone'].src='<%=language%>/images/buttondone_f2.gif';" onmouseout="document.images['buttonDone'].src='<%=language%>/images/buttondone.gif';"></a>
				</td>
			</table>
			</td>
		</tr>
		</table>
	</td>
</tr>	
</table>
</form>

</table>
</td>
</tr>
</table>

</td>
</tr>
</table>

<tr>
        <td>
            <!-- Copyright notice -->
	        <table width="100%" border="0" cellpadding="0" cellspacing="0">
                <tr>
                    <td width="100%" height="9" bgcolor="cccc99"><img src="images/pixel.gif" width="1" height="9" border="0"/></td>
	            </tr>
                <tr>
                    <td class="copyright">
	                    <%=copyright%>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
 </table>
 <script language="JavaScript1.2">
    var form = document.forms['frmOpMain'];
    if(form) {
        if (form.elements['operation']){
            form.elements['operation'].focus();
            form.elements['operation'].onkeypress=onEnter;
        }
    }

    function onEnter(keypressed) {
        // The Docment Object Model event we need is only available inf Javascript 1.2, MSIE4+ and NN4+
	    // This functions is the onKeyPress event handler for the password field
	    var key;
	    // Test	of MSIE DOM without all that parsing of the agent string
	    // NN and MSIE use different DOMs
	    if (document.all) {
	        key=window.event.keyCode;
	    }else {
	        key=keypressed.which;
	    };
	    // Check each key pressed for character code 13 (carriage return), AND
	    // then done submtit by default 'cause form has only one input field
	    if (key==13) {
            if (form.elements['operation'])
                return false;
  		}else {
            return;
        }
	}
</script>
 </body>
</html>
<% } %>
