<!--
/******************************************************************************
 *
 * Licensed Materials - Property of IBM
 *
 * Source File Name = popuplist.jsp
 *
 * (C) COPYRIGHT IBM Corp. 2003 All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 *****************************************************************************/
-->
<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="javax.ejb.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.rmi.*" %>
<%@ page import="java.net.*" %>
<%@ page import="javax.naming.*" %>
<%@ page import="javax.servlet.*" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="com.ibm.itim.logging.SystemLog" %>
<%@ page import="com.ibm.itim.dataservices.ldap.LdapMapping" %>
<%@ page import="com.ibm.itim.webclient.util.*" %>
<%@ page import="com.ibm.itim.authentication.AuthenticationException" %>
<%@ page import="com.ibm.itim.authentication.*" %>
<%@ page import="com.ibm.itim.apps.UserAuthInfo" %>
<%@ page import="com.ibm.itim.apps.exception.*" %>
<%@ page import="com.ibm.itim.common.formModel.*" %>
<%@ page import="com.ibm.itim.apps.ejb.domain.*" %>
<%@ page import="com.ibm.itim.util.*" %>

<%
        Locale localeObj = (Locale)session.getAttribute("locale");
        if (localeObj == null) {
          localeObj = LocaleUtil.getLocale(request);
          if (localeObj == null)
            localeObj = Locale.US;
        }
        I18NMessage i18NLabel = new I18NMessage(localeObj, I18NMessage.LABEL_BUNDLE);
        String localeDir = localeObj.toString();
        String selectedTypes = request.getQueryString();
        if(selectedTypes == null || selectedTypes.equals("")) {
          selectedTypes = request.getParameter("selectedTypes");
        }
        if (selectedTypes == null) {
          selectedTypes = "";
        }
        selectedTypes = URLDecoder.decode(selectedTypes);
        Set redundantTypes = new HashSet();
        StringTokenizer tokenizer = new StringTokenizer(selectedTypes, ",");
        while (tokenizer.hasMoreElements()) {
          String token = tokenizer.nextToken().trim();
          redundantTypes.add(token);
        }

	UserAuthInfo userAuthInfo = (UserAuthInfo)session.getAttribute("userAuthInfo");
	EntityManager entityManager = null;
	try {
		EntityManagerHome emh = (EntityManagerHome)EJBFactory.getHome("enroleejb.EntityManagerHome", EntityManagerHome.class);
		entityManager = emh.create();
	}
	catch (Exception e) { }
	Collection serviceProfiles = null;
	try {
		serviceProfiles = entityManager.getAllServiceProfileNames(userAuthInfo);
	} catch (Exception e) {
		e.printStackTrace();
	}
      	TreeSet objectList = null;
      	if (serviceProfiles != null)
     		objectList = new TreeSet(serviceProfiles);
%>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<meta http-equiv="Pragma" content="no-cache">
<meta http-equiv="expires" content="0">
<meta http-equiv="cache-control" content="no-cache">
    <script language="JavaScript" src="script_library.js"></script>
    <link rel="stylesheet" 
          href="<%= localeDir %>/Styles.css" 
          type="text/css" title="Styles">
<title><%=i18NLabel.getMessage("serviceConfiguration")%></title>
<script language="JavaScript">
<!--

function update(selectedValue) {
  if (window.opener && !window.opener.closed) {
    window.opener.updateServiceTypes(window.opener, selectedValue);    
    var form = document.forms['serviceTypesForm'];
    var openerForm = window.opener.document.forms['body'];
    var list = getCurrentList(openerForm);
    form.elements["selectedTypes"].value = list;
    form.submit();
  }
}
// -->
</script>
</head>
<body>
<form name="serviceTypesForm" action="popuplist.jsp" method="post">
<table border="0" cellpadding="2" width="100%">
<tr>
<td>
<table bordercolordark="white" bordercolor="lightgrey" width="100%" border="1" cellspacing="0" cellpadding="3">
<tr><td class="path"><font class="content"><%=i18NLabel.getMessage("clickAddServiceConfiguration")%></font></td></tr>
<tr><td><font class="tablelabel"><%=i18NLabel.getMessage("serviceConfiguration")%></font></td></tr>
<%
	if (objectList != null)
	{
		Iterator ite = objectList.iterator();
                Map cleanList = new HashMap();
	        while(ite.hasNext()) {
	          String name = (String)ite.next();
		  if (!name.equals(LdapMapping.SERVICE_HOSTED_PROFILE_NAME) 
		      && !name.equals(LdapMapping.SERVICE_DSML_PROFILE_NAME)
		      && !name.equals(LdapMapping.SERVICE_DSML2_PROFILE_NAME)) {
			cleanList.put(name, name);		  
		  }
                }

                Iterator it = redundantTypes.iterator();
                while(it.hasNext()) {
                  String redundantType = (String)it.next();
                  String dirtyName = (String)cleanList.get(redundantType);
                  if(dirtyName != null) {
                     cleanList.remove(dirtyName);
                  }
                }
		Set keySet = cleanList.keySet();
                Iterator iterate = keySet.iterator();
                while(iterate.hasNext()) {
                  String cleanName = (String)iterate.next();
                  String spaces = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
                  %>
			<tr class="data"><td><%=spaces%><a href="javascript:update('<%=cleanName%>')"><%=cleanName%></a></td></tr>
                  <%
                }
	}
%>
</table>
</td>
</tr>
<tr>
<td colspan="2" align="right"><a href="javascript:done()" onmouseover="document.images['buttondone'].src='<%= localeDir %>/images/buttondone_f2.gif';" onmouseout="document.images['buttondone'].src='<%= localeDir %>/images/buttondone.gif';"><img vspace="8" hspace="8" name="buttondone" border="0" alt="<%=i18NLabel.getMessage("doneAlt")%>" src="<%= localeDir %>/images/buttondone.gif"></a></td>
</tr>
</table>
<input type="hidden" name="selectedTypes">
</form>
</body>
</html>
