<%@ page language="java" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page import="javax.ejb.*" %>
<%@ page import="java.io.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.rmi.*" %>
<%@ page import="javax.naming.*" %>
<%@ page import="javax.servlet.*" %>
<%@ page import="javax.servlet.http.*" %>
<%@ page import="com.ibm.itim.webclient.util.LocaleUtil" %>
<%@ page import="com.ibm.itim.logging.SystemLog" %>
<%@ page import="com.ibm.itim.webclient.util.*" %>
<%@ page import="com.ibm.itim.webclient.applet.*" %>
<%@ page import="com.ibm.itim.webclient.home.ConfigurationTabs" %>
<%@ page import="com.ibm.itim.authentication.AuthenticationException" %>
<%@ page import="com.ibm.itim.authentication.*" %>
<%@ page import="com.ibm.itim.apps.UserAuthInfo" %>
<%@ page import="com.ibm.itim.apps.exception.*" %>
<%@ page import="com.ibm.itim.common.formModel.*" %>
<%@ page import="com.ibm.itim.common.properties.PropertiesManager" %>
<%@ page import="com.ibm.itim.apps.ejb.domain.*" %>
<%@ page import="com.ibm.itim.util.*" %>
<%@ page import="java.lang.reflect.*" %>
<%@ page import="com.ibm.itim.util.I18NMessage" %>
<%@ page import="com.ibm.itim.webclient.policy.join.PolicyJoinConstants" %>
<%@ page import="com.ibm.itim.webclient.workflow.designer.WfDesignerConstants" %>
<%@ page import="com.ibm.itim.apps.ejb.workflow.designer.*" %>
<%@ page import="com.ibm.itim.dataservices.model.*" %>
<%@ page import="com.ibm.itim.dataservices.model.system.SystemRole" %>

<%
	// Labels and Messages constant
	String DEFINE_WORKFLOW = "DEFINE_WORKFLOW";
    String DEFINE_OPERATIONS = "DEFINE_OPERATIONS";
    String ENTITY_TYPES = "ENTITY_TYPES";
    String SERVICE_CONFIG = "serviceConfig";
	String UI_CUSTOMIZE = "uiCustomize";
	String SYSADMIN = "sysAdmin";
	String ENTITY_CONFIG = "entityConfig";
    String ENTITY_TYPE_CONFIG = "entityTypeConfig";
	String PROPERTIES = "properties";
	String POLICY_JOIN = "policyJoin";
	String CHALLENGE_RESPONSE = "challengeResponse";
    String UI_PROPERTIES = "enrole.ui";
    String BUILD_VERSION = "enrole.build.version";
    String buildVersion = "0000";

	UserAuthInfo userAuthInfo = UserAuthHelper.getUserAuthInfo(request); 
  Locale localeObj = (Locale)session.getAttribute("locale");
  if (localeObj == null) {
      localeObj = LocaleUtil.getLocale(request);
  if(localeObj == null)
		localeObj = request.getLocale();
  if (localeObj == null)
		localeObj = Locale.US;
  }
  String localeDir = localeObj.toString();
  if (localeDir.equals("en_US")) {  //we don't have this en_US
        localeDir = "en";
  }
  // check that user is logged in
  String fromLogin = (String)request.getAttribute("fromLogin");
  boolean isFromLogin = (fromLogin != null) && fromLogin.equals("true");
  if ((!isFromLogin) && session.isNew()) {
	  I18NMessage i18NMessage = new I18NMessage(localeObj, I18NMessage.ERRORMESSAGES_BUNDLE);
	  String message = i18NMessage.getMessage("main.jsp.sessionTimeout");
	  request.setAttribute("message", message);
	  session.invalidate();
%>
    <jsp:forward page="/logon"/>
<%
  } else {
    I18NMessage i18NLabel = new I18NMessage(localeObj, I18NMessage.LABEL_BUNDLE);
    I18NMessage i18NMessage = new I18NMessage(localeObj, I18NMessage.MESSAGE_BUNDLE);
    	
    // directory for images and other resources
    ResourceBundle labels = ResourceBundle.getBundle(I18NMessage.LABEL_BUNDLE,
            localeObj);
    String title = labels.getString("frameTitle");
    I18NMessage messages = new I18NMessage(localeObj, I18NMessage.MESSAGE_BUNDLE);

	int systemRoleCat = userAuthInfo.getSystemRoleCategory();
	if (systemRoleCat < SystemRole.SYSTEMADMIN_CATEGORY) {
		String message = i18NMessage.getMessage("com.ibm.itim.apps.ejb.organization.ACCESS_DENIED");
		request.setAttribute("message", message);
		session.invalidate();
	%>
		<jsp:forward page="/logon"/>
	<%
	} else {
	
    try {
        buildVersion = PropertiesManager.gInstance ().getProperty (
            UI_PROPERTIES, BUILD_VERSION);
        } catch (IOException ioe) {}

    String[] args = new String[]{buildVersion};
    String copyright = messages.getMessage("copyright",args);
	String path = labels.getString ("youAreHere") + " : " + UIContext.getPathBase(request);
	String USER_ID = labels.getString("userName");
   	
	//	Calling EJBFactory.getHome(...) instead of context lookup. 
	//	For more info ref. devtrack S12664 
	EntityManagerHome entityManagerHome =
			(EntityManagerHome)EJBFactory.getHome("enroleejb.EntityManagerHome",
													com.ibm.itim.apps.ejb.domain.EntityManagerHome.class);
	EntityManager entityManager = entityManagerHome.create();

    String language = LocaleUtil.getLocale(request).getLanguage();
    String languageDirection = I18NMessage.getLanguageDirection(i18NLabel);
	String category = (String) session.getAttribute("category");
    //System.out.println("%%%% wf category = " + category);
    String categoryLabel = i18NLabel.getMessage("ObjectProfileCategory."+category);
    //System.out.println("%%%% wf category label = " + categoryLabel);
    String profileName = (String) session.getAttribute("profileName");
    //System.out.println("%%%% profileName = " + profileName);
    String mode = (String) session.getAttribute("mode");
    //System.out.println("%%%% mode = " + mode);
    String operationName = (String) request.getParameter("operationName");
    //System.out.println("%%%% operationName = " + operationName);
    String operationAction = (String) request.getParameter("operationAction");
    //System.out.println("%%%% operationAction = " + operationAction);

    //mode="entity";
    //profileName="Person";
    //category="Person";
    //operationName="ADD";
    //operationAction="modify";
    
    /** check if this is entity or entity type mode **/
	boolean entityMode = false;
	boolean entityTypeMode = false;
    if (mode != null) {
	    if (mode.equalsIgnoreCase("entity"))
			entityMode = true;
		else if (mode.equalsIgnoreCase("entitytype"))
			entityTypeMode = true;
	}

    
%>
 
 <!-- Copyright (c) 2000 by Access360. All Rights Reserved.-->
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="Pragma" content="no-cache">
    <meta http-equiv="expires" content="0">
    <meta http-equiv="cache-control" content="no-cache"> 
    <link rel="stylesheet" 
          href="<%= localeDir %>/Styles.css" 
          type="text/css" title="Styles">
    <script language="JavaScript" src="script_library.js"></script>
    <script language="JavaScript" src="image_cache.js"></script>
    <script language="JavaScript" src="help.js"></script>
    <title>
      <%= title %>
    </title>
  </head>
  <body bgcolor="white" leftmargin="0" topmargin="0" rightmargin="0" 
		marginwidth="0"	onLoad="javascript:displayMessage(document);">
    <table width=100% cellpadding=0 cellspacing=0 border="0">

    <jsp:include page="/main_menu" flush="true"/>

    <!-- Top Header Row -->
    <tr>
      <td class="topheader">
        <table cellpadding="0" cellspacing="0" border="0" width="100%">
	  <tr class="loginname">
	    <!-- Login Name -->
	    <td class="pathfinal" align="right">
			  <img src="images/pixel.gif" border="0" width="1" height="20">
	      <font bgcolor="#cccc99"><%=USER_ID%>:</font>&nbsp;
                <%=((UserAuthInfo)session.getAttribute(UserAuthHelper.USER_AUTH_INFO)).getUserID()%>
	    </td>
	  </tr>
	</table>
      </td>
    </tr>

<tr>
        <td> 
 
<table name="mainContentTable" cellpadding="0" cellspacing="0" border="0" width="100%">
<!-- For "You are here: path" bar - begin -->
<tr class="path" width="100%">
<td colspan="2" class="content" bgcolor="#e7e7cf">
<table border="0" cellspacing="0" cellpadding="0" height="100%" width="100%">

    <tr>
      <td height="1%" valign="top" colspan="3" bgcolor="#cccc99">
        <table name="pathTable" cellpadding="0" cellspacing="0" border="0" width="100%">
          <tr>
            <td background="images/bar_up_bg.gif" valign="top" height="10" colspan="2"><img height="10" width="6" border="0" src="images/bar_upper.gif"></td>
          </tr>

          <tr class="path">
            <td valign="left" width="1" height="16">
              <img src="images/pixel.gif"><img src="images/pixel.gif" width="1" height="20" border="0">
            </td>
            <td class="pathitem" valign="center" height="16" width="500" BGCOLOR="#e7e7cf">
<%
              if (languageDirection.equals(I18NMessage.LANGUAGE_DIRECTION_LTR)) {

			    if (entityTypeMode) {%>
                    <%=i18NLabel.getMessage("youAreHere")%>: <%=UIContext.getPathBase (request)%> &gt; <%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_TYPE_CONFIG)%> &gt;
                    <%=categoryLabel%> &gt; <%=i18NLabel.getMessage(DEFINE_OPERATIONS)%> &gt; <%=operationName%> &gt; <span class="pathfinal"><%=i18NLabel.getMessage(DEFINE_WORKFLOW)%></span>
                <%} else if (entityMode) {%>
                    <%=i18NLabel.getMessage("youAreHere")%>: <%=UIContext.getPathBase (request)%> &gt; <%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_CONFIG)%> &gt;
                    <%=profileName%> &gt; <%=i18NLabel.getMessage(DEFINE_OPERATIONS)%> &gt; <%=operationName%> &gt; <span class="pathfinal"><%=i18NLabel.getMessage(DEFINE_WORKFLOW)%></span>
                <%}
              }
              else if (languageDirection.equals(I18NMessage.LANGUAGE_DIRECTION_RTL)) {

                if (entityTypeMode) {%>
                    <span class="pathfinal"><%=i18NLabel.getMessage(DEFINE_WORKFLOW)%></span> &lt; <%=operationName%> &lt; <%=i18NLabel.getMessage(DEFINE_OPERATIONS)%> &lt; <%=categoryLabel%>
			        &lt; <%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_TYPE_CONFIG)%> &lt; <%=UIContext.getPathBase (request)%> :<%=i18NLabel.getMessage("youAreHere")%>
                <%} else if (entityMode) {%>
                    <span class="pathfinal"><%=i18NLabel.getMessage(DEFINE_WORKFLOW)%></span> &lt; <%=operationName%> &lt; <%=i18NLabel.getMessage(DEFINE_OPERATIONS)%> &lt; <%=profileName%>
			        &lt; <%=i18NLabel.getMessage(ConfigurationTabs.KEY_ENTITY_CONFIG)%> &lt; <%=UIContext.getPathBase (request)%> :<%=i18NLabel.getMessage("youAreHere")%>
                <%}
              }
%>

            </td>
          </tr>

          <tr>
            <td background="images/bar_lo_bg.gif" height="10" colspan="2" valign="top"><img height="10" width="6" border="0" src="images/bar_lower.gif"></td>
          </tr>
        </table>
      </td>
    </tr>

<!-- For "You are here: path" bar - end -->
<tr>
<td class="content" height="30"><img border="0" height="15" width="15" src="images/pixel.gif">
<!-- no message -->   
</td>
<td align="right"><img src="images/pixel.gif" border="0" width="5" height="1">
<a href="
<%if (entityMode) out.println(HelpUtil.getJavaScriptHelpMethod (pageContext.getServletContext(), request, "CONFIGURATION_ENTITIES_OPERATION_WORKFLOW"));
else if (entityTypeMode) out.println(HelpUtil.getJavaScriptHelpMethod (pageContext.getServletContext(), request, "CONFIGURATION_ENTITY_TYPE_OPERATION_WORKFLOW"));%>
"><img name="helpquestion" src="images/question.gif" width="16" height="16" hspace="2" border="0" onmouseover="document.images['helpquestion'].src='images/question_f2.gif';" onmouseout="document.images['helpquestion'].src='images/question.gif';"></a>
</td>
</tr>
</table>
</td>
</tr>
 
<form name="body">
<input type="hidden" name="target">
<input type="hidden" name="UIContext" value="configuration">
<input type="hidden" name="operation" value="">
<input type="hidden" name="tab_index" value="">
<tr>
<td width="5">&nbsp;&nbsp;</td><td valign="top">
<table border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<br>
</td>
</tr>
<tr>
<td>

    <table cellpadding="0" cellspacing="0" width="100%" border="0">
      <tr>
      <td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('service_profiles_servlet')"><%=i18NLabel.getMessage(SERVICE_CONFIG)%></a></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('form_designer')"><%=i18NLabel.getMessage(UI_CUSTOMIZE)%></a></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
	<table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('system_role_disp','','admin')"><%=i18NLabel.getMessage(SYSADMIN)%></a></td>
	  </tr>
	</table>
      </td>
      
     <%if (entityTypeMode) {%>  
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="activetab"><font style="font-size: 8pt; color: #000000; font-weight: bold;"><%=i18NLabel.getMessage(ENTITY_TYPE_CONFIG)%></font></td>
          </tr>
        </table>
      </td>
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight : bold;" href="javascript:switchToSelectedTabs('entity_list')"><%=i18NLabel.getMessage(ENTITY_CONFIG)%></a></td>
	  </tr>
	</table>
      </td>
      <%}else{%>
      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
          <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('entityTypeConfig.jsp')"><%=i18NLabel.getMessage(ENTITY_TYPE_CONFIG)%></a></td>
          </tr>
        </table>
      </td>

      <td class="tabspacer"></td><td align="center">
        <table cellspacing="0" width="100%" border="0">
          <tr align="center">
	  <td height="25" class="activetab"><font style="font-size: 8pt; color: #000000; font-weight : bold;"><%=i18NLabel.getMessage(ENTITY_CONFIG)%></font></td>
	  </tr>
	</table>
      </td>

      <%}%>
      
      <td class="tabspacer"></td>
      <td align="center">
	<table cellspacing="0" width="100%" border="0">
	  <tr align="center">
	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('system_properties')"><%=i18NLabel.getMessage(PROPERTIES)%></a></td>
	  </tr>
	</table>
      </td>
      <td class="tabspacer"></td>
      <td align="center">
      	<table cellspacing="0" width="100%" border="0">
      	  <tr align="center">
      	  <td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('policy_join_directives')"><%=i18NLabel.getMessage(POLICY_JOIN)%></a></td>
      	  </tr>
      	</table>
            </td>
      <td class="tabspacer"></td>
      <td align="center">
      	<table cellspacing="0" width="100%" border="0">
      	  <tr align="center">
		<td height="25" class="inactivetab"><a style="font-size: 8pt; color: #000000; font-weight: bold;" href="javascript:switchToSelectedTabs('challenge_response_config')"><%=i18NLabel.getMessage(CHALLENGE_RESPONSE)%></a></td>
      	  </tr>
      	</table>
            </td>
      <td class="tabspacer"></td>
      </tr>
    </table>
  </td>
</tr>
</form>

<tr width="100%">
<td class="content" bgcolor="#e7e7cf"><img border="0" height="5" width="15" src="images/pixel.gif"><br>
</td>
</tr>
<tr bgcolor="e7e7cf">
<td>


<% 

String[] locale = { LocaleUtil.getLocale(request).getLanguage(), LocaleUtil.getLocale(request).getCountry() };
String sessionId = session.getId();


        PropertiesManager propsMgr = PropertiesManager.gInstance ();
		// classid is just for IE
		String classid    = propsMgr.getProperty ("enrole.ui", "enrole.java.plugin.classid");
		String javaPlugIn = propsMgr.getProperty ("enrole.ui", "enrole.java.plugin");
		
		// java plug-in download page for netscape browser.
		String pluginsPage  = propsMgr.getProperty ("enrole.ui", "enrole.java.pluginspage");
		String jpiVersion   = propsMgr.getProperty ("enrole.ui", "enrole.java.plugin.jpi-version");
		
		// the build version id for enrole to be used as the workflow designer version.
		//String buildVersion = propsMgr.getProperty ("enrole.ui", "enrole.build.version");
		if (buildVersion.startsWith ("%")) buildVersion = "1";

        //cacheArchives.put ("JoinDirectiveApplet.jar", "4.0.0." + buildVersion);
        Hashtable cacheArchives = new Hashtable ();
		cacheArchives.put ("WfDesignerApplet.jar", "4.5.0." + buildVersion);
		cacheArchives.put ("JGo.jar"             , "3.0.0.0");
		cacheArchives.put ("JGoLayout.jar"       , "3.0.0.0");
		cacheArchives.put ("xerces.jar"          , "1.1.3.0");

        
        Hashtable parameters = new Hashtable ();
        //parameters.put (PolicyJoinConstants.PARAM_NAME_LOCALE        , locale.toString());
        //parameters.put (PolicyJoinConstants.PARAM_NAME_BUILD_VERSION , buildVersion);
        //parameters.put (PolicyJoinConstants.PARAM_NAME_SESSION_ID    , session.getId());

        ObjectProfile objectProfile = null;
        ObjectProfileOperation objectProfileOperation = null;
        ObjectProfileCategory objectProfileCategory = null;
        DistinguishedName dn = null;
        DistinguishedName tenantDN = null;
        String tenantDNstr = userAuthInfo.getTenantDN();
        if (tenantDNstr != null && tenantDNstr.length()>0) tenantDN = new DistinguishedName(tenantDNstr);

        if (operationAction.equalsIgnoreCase("add"))
			parameters.put (WfDesignerConstants.PARAM_NAME_STATE, WfDesignerConstants.PARAM_VAL_STATE_NEW);
        else {
            parameters.put (WfDesignerConstants.PARAM_NAME_STATE, WfDesignerConstants.PARAM_VAL_STATE_OPEN);
            if (entityMode && profileName != null) {
                objectProfile = entityManager.getDetails(userAuthInfo, profileName);
                if (objectProfile != null) {
                    objectProfileOperation = objectProfile.getOperation(operationName);
                    if (objectProfileOperation != null) {
                        dn = objectProfileOperation.getDefinitionDN();
                        parameters.put (WfDesignerConstants.PARAM_NAME_CUSTOM_PROCESS_INFO_DN, dn);
                    }
                }
            } else if (entityTypeMode) {
                if (category != null && tenantDN != null) {
                    objectProfileCategory = CategoryTable.getInstance(tenantDN).getCategory(category);
                    if (objectProfileCategory != null) {
                        objectProfileOperation = objectProfileCategory.getOperation(operationName);
                        if (objectProfileOperation != null) {
                            dn = objectProfileOperation.getDefinitionDN();
                            parameters.put (WfDesignerConstants.PARAM_NAME_CUSTOM_PROCESS_INFO_DN, dn);
                        }
                    }
                }
            }
        }
        parameters.put (WfDesignerConstants.PARAM_NAME_PROCESS_DEF_ID, operationName);
        parameters.put (WfDesignerConstants.PARAM_NAME_SESSION_ID, sessionId);
        parameters.put (WfDesignerConstants.PARAM_NAME_LOCALE, locale.toString());
        parameters.put (WfDesignerConstants.PARAM_NAME_BUILD_VERSION , buildVersion);
        parameters.put (WfDesignerConstants.PARAM_NAME_WFTYPE, WfDesignerConstants.PARAM_VAL_WFTYPE_OP);
        parameters.put (WfDesignerConstants.PARAM_NAME_ENTITYTYPE_NAME , category);
        parameters.put (WfDesignerConstants.PARAM_NAME_ENTITY_NAME , profileName);
        parameters.put (WfDesignerConstants.PARAM_NAME_TENANT_DN , userAuthInfo.getTenantDN());
        
        //System.out.println("%%%% classid = " + classid);
        //System.out.println("%%%% jpiVersion = " + jpiVersion);
        //System.out.println("%%%% javaPlugIn = " + javaPlugIn);
        //System.out.println("%%%% pluginsPage = " + pluginsPage);
        //System.out.println("%%%% cacheArchives = " + cacheArchives.toString());
        //System.out.println("%%%% parameters = " + parameters.toString());

        AppletPluginTag appletPluginTag = new AppletPluginTag (
            "com.ibm.itim.webclient.workflow.designer.applet.WfDesignerApplet.class", // code
        	"800",        // widthOnIE
        	"480",        // heightOnIE
        	"800",         // widthOnNS
        	"480",         // heightOnNS
        	"WfDesignerApplet",    // id for Object tag
        	classid,       // classid
        	jpiVersion,    // jpiVersion
        	javaPlugIn,    // pluginLocForIE
        	pluginsPage,   // pluginLocForNS
        	"Plugin",      // cacheOption
        	cacheArchives, // cacheArchives
        	parameters     // parameters
        );
		String appletPluginTagStr = appletPluginTag.toString();
        //System.out.println("%%%% appletPluginTagStr = " + appletPluginTagStr);
    %>
        <%=appletPluginTagStr%>
</table>
</td>
</tr>
</table>

</td>
</tr>
</table>

 <tr>
        <td>
            <!-- Copyright notice -->
	        <table width="100%" border="0" cellpadding="0" cellspacing="0">
                <tr>
                    <td width="100%" height="9" bgcolor="cccc99"><img src="images/pixel.gif" width="1" height="9" border="0"/></td>
	            </tr>
                <tr>
                    <td class="copyright">
	                    <%=copyright%>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
 </table>
   
 </body>
</html>
<% }
} %>

